"""
Django settings for my_app project.

Generated by 'django-admin startproject' using Django 3.2.

For more information on this file, see
https://docs.djangoproject.com/en/3.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.2/ref/settings/
"""

from pathlib import Path
import django_q
import environ
from django.core.exceptions import ImproperlyConfigured

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent

env = environ.Env()

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'django-insecure-fjz+d024)z6t)(so%yvsboc8bk^)(zeg0)w9uj8_c&ppv@woi*'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG=True

CORS_ORIGIN_ALLOW_ALL = DEBUG

ALLOWED_HOSTS = ['host.docker.internal', 'localhost']


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'django_q',
    'django_prometheus',
]

MIDDLEWARE = [
    'django_prometheus.middleware.PrometheusBeforeMiddleware',
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'django_prometheus.middleware.PrometheusAfterMiddleware',
]

ROOT_URLCONF = 'my_app.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [
            'polls/templates'
        ],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'my_app.wsgi.application'


# Database
# https://docs.djangoproject.com/en/3.2/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django_prometheus.db.backends.mysql',
        'NAME': 'my_app_mysql',
        'USER': env.str('DATABASE_USER'),
        'PASSWORD': env.str('DATABASE_PASSWORD'),
        'HOST': 'mysql',
        'PORT': env.str('DATABASE_PORT'),
    },
    'tq_mysql': {
        'ENGINE': 'django_prometheus.db.backends.mysql',
        'NAME': 'tq_default_mysql',
        'USER': env.str('DATABASE_USER'),
        'PASSWORD': env.str('DATABASE_PASSWORD'),
        'HOST': 'tq_default_mysql',
        'PORT': env.str('DATABASE_PORT'),
    }
}

# nedded so that each model and model usage goes to its own DB
DATABASE_ROUTERS = ['my_app.db_routers.DjangoQRouter']


# Password validation
# https://docs.djangoproject.com/en/3.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/3.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.2/howto/static-files/

STATIC_URL = '/static/'

# Default primary key field type
# https://docs.djangoproject.com/en/3.2/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'


Q_CLUSTER = {
    # default cluster config
    'name': 'cluster_name_1',
    'workers': 5,
    'timeout': 60,
    'retry': 90,
    'max_attempts': 2,
    'bulk': 4,
    'catch_up': False,
    'orm': 'tq_mysql',
    'ALT_CLUSTERS': {
        # INSURANCE cluster config
        'INSURANCE': {
            'workers': 2,
            'timeout': 60,
            'retry': 90,
            'max_attempts': 2,
            'bulk': 4,
            'catch_up': False,
            'orm': 'tq_mysql',
        }
    }
}

# Quick and Dirty Caches. Needed for Django Q Monitoring
# (we probably want a better cache system, not using the main DB)
CACHES = {
    'default': {
        'BACKEND': 'django.core.cache.backends.db.DatabaseCache',
        'LOCATION': 'my_cache_table',
    }
}


# MONKEY PATCH
# I'm monkey-patching Django-Q's `Stat` class so we can have
# the queue name in the `Stat`
from django_q.status import Stat
_old_init = Stat.__init__
def _new_init(self, *args, **kwargs):
    _old_init(self, *args, **kwargs)
    b = django_q.brokers.get_broker()
    self.list_key = b.list_key
Stat.__init__ = _new_init
